// Chimères Orchestra
// Raspberry Pi > Pd > Serial > Arduino MEGA > MOSFETS
// Digital sensor to activate

#include "PwmMotor.h"

// ---- CONFIGURATIONS ---- //
int pins[] = {3,5,6,9,10,11}; // pins Shield Mosfets
int time_max = 150;
boolean DEBUG = false;

// ---- VARIABLES --------- //
int id, pwm, time;
const int nb = 6;
PwmMotor motors[nb];
unsigned long current = 0;

unsigned long button_interval = 50;
unsigned long button_previous = 0;
int button_state = 0;
int button_last_state = 0;
int button_pin = 2; //2,4,7,8,12,13


// ---- PROGRAM ----------- //
void setup() {
  Serial.begin(38400);
   for (int i; i < nb; i++) {
     motors[i].init(pins[i], time_max, DEBUG);
  }
}

void loop() {
  current = millis();
  
  // Sensor
  if(current - button_previous > button_interval) { // sampling
      button_previous = current; 
      button_state = digitalRead(button_pin);
      if (button_state != button_last_state) {       // if the state has changed
        Serial.println(button_state);
      }
      button_last_state = button_state;
  }

  // ON
  while (Serial.available()) {
     id = Serial.parseInt(); 
     pwm = Serial.parseInt();
     time = Serial.parseInt();
     if (Serial.read() == '\n') {
       if( motors[id].isOn() == false )  motors[id].on(current, pwm, time);
     }
   }
  
  // OFF
  for (int i; i < nb; i++) {
     if( motors[i].isOn() ) motors[i].off(current);
  }
  
  delay(5);
}
